=== src/Makefile ===
#
# Library Makefile for the Fast Light Tool Kit (FLTK).
#
# Copyright 1998-2024 by Bill Spitzak and others.
#
# This library is free software. Distribution and use rights are outlined in
# the file "COPYING" which should have been included with this file.  If this
# file is missing or damaged, see the license at:
#
#      https://www.fltk.org/COPYING.php
#
# Please see the following page on how to report bugs and issues:
#
#      https://www.fltk.org/bugs.php
#

# Note:	see ../configure.ac and/or ../makeinclude for definition of
#	FL_VERSION (x.y.z), FL_ABI_VERSION (x.y.0), and FL_DSO_VERSION (x.y)

CPPFILES = \
	Fl.cxx \
	Fl_Adjuster.cxx \
	Fl_Bitmap.cxx \
	Fl_Browser.cxx \
	Fl_Browser_.cxx \
	Fl_Browser_load.cxx \
	Fl_Box.cxx \
	Fl_Button.cxx \
	Fl_Cairo.cxx \
	Fl_Chart.cxx \
	Fl_Check_Browser.cxx \
	Fl_Check_Button.cxx \
	Fl_Choice.cxx \
	Fl_Clock.cxx \
	Fl_Color_Chooser.cxx \
	Fl_Copy_Surface.cxx \
	Fl_Counter.cxx \
	Fl_Dial.cxx \
	Fl_Device.cxx \
	Fl_Double_Window.cxx \
	Fl_File_Browser.cxx \
	Fl_File_Chooser.cxx \
	Fl_File_Chooser2.cxx \
	Fl_File_Icon.cxx \
	Fl_File_Input.cxx \
	Fl_Flex.cxx \
	Fl_Graphics_Driver.cxx \
	Fl_Grid.cxx \
	Fl_Group.cxx \
	Fl_Help_View.cxx \
	Fl_Image.cxx \
	Fl_Image_Surface.cxx \
	Fl_Input.cxx \
	Fl_Input_.cxx \
	Fl_Input_Choice.cxx \
	Fl_Int_Vector.cxx \
	Fl_Light_Button.cxx \
	Fl_Menu.cxx \
	Fl_Menu_.cxx \
	Fl_Menu_Bar.cxx \
	Fl_Menu_Button.cxx \
	Fl_Menu_Window.cxx \
	Fl_Menu_add.cxx \
	Fl_Menu_global.cxx \
	Fl_Message.cxx \
	Fl_Multi_Label.cxx \
	Fl_Native_File_Chooser.cxx \
	Fl_Overlay_Window.cxx \
	Fl_Pack.cxx \
	Fl_Paged_Device.cxx \
	Fl_Pixmap.cxx \
	Fl_Positioner.cxx \
	Fl_Preferences.cxx \
	Fl_Printer.cxx \
	Fl_Progress.cxx \
	Fl_Repeat_Button.cxx \
	Fl_Return_Button.cxx \
	Fl_Roller.cxx \
	Fl_Round_Button.cxx \
	Fl_Screen_Driver.cxx \
	Fl_Scheme.cxx \
	Fl_Scheme_Choice.cxx \
	Fl_Scroll.cxx \
	Fl_Scrollbar.cxx \
	Fl_Shared_Image.cxx \
	Fl_Shortcut_Button.cxx \
	Fl_Single_Window.cxx \
	Fl_Slider.cxx \
	Fl_Spinner.cxx \
	Fl_String.cxx \
	Fl_Sys_Menu_Bar.cxx \
	Fl_System_Driver.cxx \
	Fl_Table.cxx \
	Fl_Table_Row.cxx \
	Fl_Tabs.cxx \
	Fl_Terminal.cxx \
	Fl_Text_Buffer.cxx \
	Fl_Text_Display.cxx \
	Fl_Text_Editor.cxx \
	Fl_Tile.cxx \
	Fl_Tiled_Image.cxx \
	Fl_Timeout.cxx \
	Fl_Tree.cxx \
	Fl_Tree_Item.cxx \
	Fl_Tree_Item_Array.cxx \
	Fl_Tree_Prefs.cxx \
	Fl_Tooltip.cxx \
	Fl_Valuator.cxx \
	Fl_Value_Input.cxx \
	Fl_Value_Output.cxx \
	Fl_Value_Slider.cxx \
	Fl_Widget.cxx \
	Fl_Widget_Surface.cxx \
	Fl_Window.cxx \
	Fl_Window_Driver.cxx \
	Fl_Window_fullscreen.cxx \
	Fl_Window_hotspot.cxx \
	Fl_Window_iconize.cxx \
	Fl_Wizard.cxx \
	Fl_XBM_Image.cxx \
	Fl_XPM_Image.cxx \
	Fl_abort.cxx \
	Fl_add_idle.cxx \
	Fl_arg.cxx \
	Fl_compose.cxx \
	Fl_display.cxx \
	Fl_get_system_colors.cxx \
	Fl_grab.cxx \
	Fl_lock.cxx \
	Fl_own_colormap.cxx \
	Fl_visual.cxx \
	filename_absolute.cxx \
	filename_expand.cxx \
	filename_ext.cxx \
	filename_isdir.cxx \
	filename_list.cxx \
	filename_match.cxx \
	filename_setext.cxx \
	fl_arc.cxx \
	fl_ask.cxx \
	fl_boxtype.cxx \
	fl_color.cxx \
	fl_contrast.cxx \
	fl_cursor.cxx \
	fl_curve.cxx \
	fl_diamond_box.cxx \
	fl_draw.cxx \
	fl_draw_arrow.cxx \
	fl_draw_pixmap.cxx \
	fl_encoding_latin1.cxx \
	fl_encoding_mac_roman.cxx \
	fl_engraved_label.cxx \
	fl_file_dir.cxx \
	fl_font.cxx \
	fl_gleam.cxx \
	fl_gtk.cxx \
	fl_labeltype.cxx \
	fl_open_uri.cxx \
	fl_oval_box.cxx \
	fl_overlay.cxx \
	fl_oxy.cxx \
	fl_plastic.cxx \
	fl_read_image.cxx \
	fl_rect.cxx \
	fl_round_box.cxx \
	fl_rounded_box.cxx \
	fl_set_font.cxx \
	fl_scroll_area.cxx \
	fl_shadow_box.cxx \
	fl_shortcut.cxx \
	fl_show_colormap.cxx \
	fl_string_functions.cxx \
	fl_symbols.cxx \
	fl_utf8.cxx \
	fl_vertex.cxx \
	print_button.cxx \
	screen_xywh.cxx

OBJCPPFILES = \
	Fl_cocoa.mm \
	drivers/Cocoa/Fl_Cocoa_Printer_Driver.mm \
	Fl_Native_File_Chooser_MAC.mm \
	Fl_MacOS_Sys_Menu_Bar.mm

FLCPPFILES = \
	forms_compatibility.cxx \
	forms_bitmap.cxx \
	forms_free.cxx \
	forms_fselect.cxx \
	forms_pixmap.cxx \
	forms_timer.cxx

GLCPPFILES = \
	Fl_Gl_Choice.cxx \
	Fl_Gl_Overlay.cxx \
	Fl_Gl_Device_Plugin.cxx \
	Fl_Gl_Window.cxx \
	freeglut_geometry.cxx \
	freeglut_stroke_mono_roman.cxx \
	freeglut_stroke_roman.cxx \
	freeglut_teapot.cxx \
	gl_draw.cxx \
	gl_start.cxx \
	glut_compatibility.cxx \
	glut_font.cxx \
	drivers/OpenGL/Fl_OpenGL_Display_Device.cxx \
	drivers/OpenGL/Fl_OpenGL_Graphics_Driver_arci.cxx \
	drivers/OpenGL/Fl_OpenGL_Graphics_Driver_color.cxx \
	drivers/OpenGL/Fl_OpenGL_Graphics_Driver_font.cxx \
	drivers/OpenGL/Fl_OpenGL_Graphics_Driver_line_style.cxx \
	drivers/OpenGL/Fl_OpenGL_Graphics_Driver_rect.cxx \
	drivers/OpenGL/Fl_OpenGL_Graphics_Driver_vertex.cxx

GLOBJCPPFILES = drivers/Cocoa/Fl_Cocoa_Gl_Window_Driver.mm
GLCPPFILES_X11 = drivers/X11/Fl_X11_Gl_Window_Driver.cxx
GLCPPFILES_XFT = $(GLCPPFILES_X11)
GLCPPFILES_CAIRO = $(GLCPPFILES_X11)
GLCPPFILES_WIN = drivers/WinAPI/Fl_WinAPI_Gl_Window_Driver.cxx
GLCPPFILES_WAYLAND = drivers/Wayland/Fl_Wayland_Gl_Window_Driver.cxx
GLCPPFILES_WAYLANDX11 = $(GLCPPFILES_WAYLAND) \
		        drivers/X11/Fl_X11_Gl_Window_Driver.cxx

GLCPPFILES += $(GLCPPFILES_$(BUILD))
GLMMFILES_OSX = $(GLOBJCPPFILES)
GLMMFILES = $(GLMMFILES_$(BUILD))

#	the following file currently doesn't contribute code to GLCPPFILES
#	drivers/OpenGL/Fl_OpenGL_Graphics_Driver.cxx

IMGCPPFILES = \
	fl_images_core.cxx \
	fl_write_png.cxx \
	Fl_BMP_Image.cxx \
	Fl_File_Icon2.cxx \
	Fl_GIF_Image.cxx \
	Fl_Anim_GIF_Image.cxx \
	Fl_Help_Dialog.cxx \
	Fl_ICO_Image.cxx \
	Fl_JPEG_Image.cxx \
	Fl_PNG_Image.cxx \
	Fl_PNM_Image.cxx \
	Fl_Image_Reader.cxx \
	Fl_SVG_Image.cxx \
	nanosvg.cxx \
	drivers/SVG/Fl_SVG_File_Surface.cxx

CFILES = flstring.c numericsort.c vsnprintf.c
CFILES_WIN = fl_call_main.c

UTF8CFILES = \
	xutf8/case.c \
	xutf8/is_right2left.c \
	xutf8/is_spacing.c

QUARTZCPPFILES = \
	drivers/Quartz/Fl_Quartz_Graphics_Driver.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_color.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_rect.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_font.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_vertex.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_image.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_arci.cxx \
	drivers/Quartz/Fl_Quartz_Graphics_Driver_line_style.cxx \
	drivers/Quartz/Fl_Quartz_Copy_Surface_Driver.cxx \
	drivers/Quartz/Fl_Quartz_Image_Surface_Driver.cxx \
	drivers/Cocoa/Fl_Cocoa_Window_Driver.cxx \
	drivers/Cocoa/Fl_Cocoa_Screen_Driver.cxx \
        drivers/Posix/Fl_Posix_System_Driver.cxx \
	drivers/Darwin/Fl_Darwin_System_Driver.cxx \
	drivers/Darwin/fl_macOS_platform_init.cxx \
        Fl_get_key_mac.cxx

# These C++ files are used under condition: BUILD_X11
XLIBCPPFILES = \
	drivers/Xlib/Fl_Xlib_Copy_Surface_Driver.cxx \
	drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx \
	drivers/X11/Fl_X11_Window_Driver.cxx \
	drivers/X11/Fl_X11_Screen_Driver.cxx \
	drivers/Posix/Fl_Posix_System_Driver.cxx \
        drivers/Unix/Fl_Unix_System_Driver.cxx \
	drivers/Unix/Fl_Unix_Screen_Driver.cxx \
	drivers/Posix/Fl_Posix_Printer_Driver.cxx \
	drivers/X11/fl_X11_platform_init.cxx \
	Fl_x.cxx \
	fl_dnd_x.cxx \
        Fl_Native_File_Chooser_FLTK.cxx \
	Fl_Native_File_Chooser_GTK.cxx\
	Fl_Native_File_Chooser_Kdialog.cxx \
	Fl_Native_File_Chooser_Zenity.cxx \
        Fl_get_key.cxx

# These graphics driver files are used under condition: BUILD_CAIRO
CAIROGDFILES = \
	drivers/Cairo/Fl_Cairo_Graphics_Driver.cxx \
	drivers/Cairo/Fl_X11_Cairo_Graphics_Driver.cxx

# These graphics driver files are used under condition: BUILD_X11 AND BUILD_XFT
XLIBGDFILES = drivers/Xlib/Fl_Xlib_Graphics_Driver.cxx \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_arci.cxx \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_color.cxx \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_image.cxx \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_line_style.cxx \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_rect.cxx \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_vertex.cxx

# These C++ files are used under conditions: BUILD_WAYLAND or BUILD_WAYLANDX11
WLCPPFILES = \
	drivers/Posix/Fl_Posix_Printer_Driver.cxx \
        Fl_Native_File_Chooser_FLTK.cxx \
        Fl_Native_File_Chooser_GTK.cxx \
	Fl_Native_File_Chooser_Kdialog.cxx \
	Fl_Native_File_Chooser_Zenity.cxx \
	drivers/Posix/Fl_Posix_System_Driver.cxx \
        drivers/Unix/Fl_Unix_System_Driver.cxx \
        drivers/Unix/Fl_Unix_Screen_Driver.cxx \
	drivers/Wayland/Fl_Wayland_Screen_Driver.cxx \
        drivers/Wayland/Fl_Wayland_Window_Driver.cxx \
	drivers/Wayland/Fl_Wayland_Image_Surface_Driver.cxx \
	drivers/Wayland/Fl_Wayland_Copy_Surface_Driver.cxx \
	drivers/Wayland/Fl_Wayland_Graphics_Driver.cxx \
	drivers/Wayland/fl_wayland_platform_init.cxx \
	drivers/Wayland/fl_wayland_clipboard_dnd.cxx

# These C++ files are used under condition: BUILD_WAYLANDX11
WLX11CPPFILES = \
	drivers/X11/Fl_X11_Screen_Driver.cxx \
	drivers/X11/Fl_X11_Window_Driver.cxx \
	drivers/Cairo/Fl_X11_Cairo_Graphics_Driver.cxx \
	drivers/Xlib/Fl_Xlib_Copy_Surface_Driver.cxx \
	drivers/Xlib/Fl_Xlib_Image_Surface_Driver.cxx \
	Fl_x.cxx \
	fl_dnd_x.cxx \
	Fl_get_key.cxx


#   fl_dnd_x.cxx  Fl_Native_File_Chooser_GTK.cxx

# This C file is used under condition: BUILD_X11
XLIBCFILES = \
        xutf8/keysym2Ucs.c \
        scandir_posix.c

# These C files are used under condition: BUILD_X11 AND NOT BUILD_XFT
XLIBXCFILES = \
        xutf8/utf8Input.c \
        xutf8/utf8Utils.c \
        xutf8/utf8Wrap.c

# These C++ files are used under condition: BUILD_X11 AND NOT BUILD_XFT
XLIBFONTFILES = \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_font_x.cxx

# These C++ files are used under condition: BUILD_X11 AND BUILD_XFT
XLIBXFTFILES = \
	drivers/Xlib/Fl_Xlib_Graphics_Driver_font_xft.cxx \
	drivers/Cairo/Fl_Cairo_Graphics_Driver.cxx

# This C file is used under condition: BUILD_WAYLAND
WLCFILES = \
        xutf8/keysym2Ucs.c \
        scandir_posix.c

# These C++ files are used under conditions: BUILD_WAYLAND or BUILD_WAYLANDX11
WLXFTFILES = \
	drivers/Cairo/Fl_Cairo_Graphics_Driver.cxx

# These C++ files are used under condition: BUILD_GDI
GDICPPFILES = \
	drivers/GDI/Fl_GDI_Graphics_Driver.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_arci.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_color.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_font.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_image.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_line_style.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_rect.cxx \
	drivers/GDI/Fl_GDI_Graphics_Driver_vertex.cxx \
	drivers/GDI/Fl_GDI_Copy_Surface_Driver.cxx \
	drivers/GDI/Fl_GDI_Image_Surface_Driver.cxx \
	drivers/WinAPI/Fl_WinAPI_Window_Driver.cxx \
	drivers/WinAPI/Fl_WinAPI_Screen_Driver.cxx \
	drivers/WinAPI/Fl_WinAPI_System_Driver.cxx \
	drivers/WinAPI/Fl_WinAPI_Printer_Driver.cxx \
	drivers/WinAPI/fl_WinAPI_platform_init.cxx \
	Fl_win32.cxx \
	fl_dnd_win32.cxx \
        Fl_Native_File_Chooser_WIN32.cxx \
        Fl_get_key_win32.cxx

# These C files are used under condition: BUILD_GDI
GDICFILES = \
        scandir_win32.c

PSCPPFILES = \
	drivers/PostScript/Fl_PostScript.cxx \
	drivers/PostScript/Fl_PostScript_image.cxx

################################################################
FLTKFLAGS = -DFL_LIBRARY
include ../makeinclude

# makeinclude has set this variable:
# BUILD = {WIN|X11|XFT|CAIRO|OSX|WAYLAND|WAYLANDX11}

MMFILES_OSX = $(OBJCPPFILES)
MMFILES = $(MMFILES_$(BUILD))

CPPFILES += $(PSCPPFILES)
CPPFILES_OSX = $(QUARTZCPPFILES)

CPPFILES_XFT = $(XLIBCPPFILES) $(XLIBGDFILES) $(XLIBXFTFILES)
CPPFILES_X11 = $(XLIBCPPFILES) $(XLIBGDFILES) $(XLIBFONTFILES)
CPPFILES_CAIRO = $(XLIBCPPFILES) $(CAIROGDFILES)

CPPFILES_WAYLAND = $(WLCPPFILES) $(WLXFTFILES)
CPPFILES_WAYLANDX11 = $(CPPFILES_WAYLAND) $(WLX11CPPFILES)

CPPFILES_WIN = $(GDICPPFILES)

CPPFILES += $(CPPFILES_$(BUILD))


CFILES_X11 = $(XLIBCFILES) $(XLIBXCFILES)
CFILES_CAIRO = $(XLIBCFILES)
CFILES_XFT = $(XLIBCFILES)

CFILES_WAYLANDX11 = $(WLCFILES)
EXTRA_OBJECTS_WAYLAND =  ../libdecor/build/fl_libdecor.o ../libdecor/build/libdecor-cairo-blur.o \
