=== debian/changelog ===
fltk1.4 (1.4.4-2) unstable; urgency=medium

  * Clean up stray "NOT RELEASED YET" note in previous entry.
  * debian/libfltk1.4.symbols.wayland: Mark the two symbols historically
    conditionalized on m68k or !m68k as optional.  As of version 14, GCC
    yields an out-of-line definition of the same vector<int> member
    function on m68k as it already did everywhere else (realloc_append
    rather than realloc_insert).  Relying on that behavior would need to
    be reverted for any backports (assuming they come into play at all on
    second-class "ports" architectures), and any clients that use either
    function should get a definition straight from libstdc++, so any
    fluctuations in which (if either!) shows up here should be harmless.

 -- Aaron M. Ucko <ucko@debian.org>  Fri, 17 Oct 2025 14:49:58 -0400

fltk1.4 (1.4.4-1) unstable; urgency=medium

  [ Alexandre Detiste ]
  * Update Vcs-* urls.
  * Drop "Rules-Requires-Root: no": it is the new default.

  [ Aaron M. Ucko ]
  * New upstream release.
  * debian/FLTK-Targets-none-tail.cmake: Never insist on fltk::options.
  * debian/control:
    - Build-Depends-Indep: Add texlive-fonts-{extra,recommended}
      and texlive-pictures, collectively needed for new Unicode character
      declarations.
    - Reflect the move to the new Debian FLTK Ecosystem Team (albeit with
      myself as the only uploader, at least for now).
    - Reformat via "cme fix dpkg-control" (routine-update).
  * debian/fix-fltk-targets: Drop extraneous *-shared executable stanzas
    (including all games') rather than mistaking them for shared
    libraries' (or even ignoring them).   (Closes: #1112001.)
  * debian/libfltk1.4.symbols.common: Add the one new symbol.
  * documentation/CMakeLists.txt: Account for the new latex-extras.sty
    (nominally configurable so a copy ends up in the build tree).
  * documentation/Doxyfile.in: Use it.
  * documentation/latex-extras.sty (new):
    - Supply a fallback definition of \insert@pcolumn based on the
      traditional (late 1980s-2023) definition of \insert@column to work
      around an incompatibility (#1114077) between the old version of
      array.sty Doxygen's preserved copy of archaic tabu.sty requires and
      other portions of TeX Live 2025.  (Closes: #1112923, #1114104.)
    - Ensure LaTeX knows what to make of all Unicode characters in the
      input.

  [ Manolo Gouy ]
  * src/drivers/wayland/Fl_Wayland_Window_Driver.cxx: Stop calling
    non-public libdecor_frame_get_content_{width,height}.
    (Closes: 1111540.)

 -- Aaron M. Ucko <ucko@debian.org>  Thu, 16 Oct 2025 14:30:20 -0400
