=== debian/control ===
Source: fltk1.4
Standards-Version: 4.7.2
Maintainer: Debian FLTK Ecosystem Team <team+fltk@tracker.debian.org>
Uploaders:
 Aaron M. Ucko <ucko@debian.org>,
Section: libs
Priority: optional
Build-Depends:
 cmake,
 debhelper-compat (= 13),
 fluid (>= 1.4) <cross>,
 libcairo2-dev,
 libgl-dev | libgl1-mesa-dev,
 libglu1-mesa-dev | libglu-dev,
 libjpeg-dev,
 libpng-dev,
 libx11-dev,
 libxcursor-dev,
 libxext-dev,
 libxft-dev,
 libxinerama-dev,
 pkgconf,
 zlib1g-dev | libz-dev,
Build-Depends-Arch:
 libasound2-dev [linux-any],
 libdbus-1-dev,
 libegl-dev,
 libdecor-0-dev (>= 0.2.0) [linux-any] | libgtk-3-dev [linux-any],
 libdecor-0-plugin-1-gtk [linux-any],
 libglew-dev,
 libpango1.0-dev,
 libwayland-dev [linux-any],
 libxkbcommon-dev,
 wayland-protocols [linux-any],
Build-Depends-Indep:
 doxygen-latex,
 texlive-font-utils,
 texlive-fonts-extra,
 texlive-fonts-recommended,
 texlive-latex-extra,
 texlive-pictures,
 xauth,
 xvfb,
Vcs-Browser: https://salsa.debian.org/fltk-team/fltk1.4
Vcs-Git: https://salsa.debian.org/fltk-team/fltk1.4.git
Homepage: https://www.fltk.org/

Package: fluid
Architecture: any
Multi-Arch: foreign
Section: devel
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 fltk1.4-doc,
 libfltk1.4-dev,
Description: Fast Light Toolkit - user interface designer
 This package provides Fluid, an interactive GUI designer for FLTK,
 allowing graphical development of FLTK-based user
 interfaces. It natively works with (textual) .fl files, but also
 includes rough support for reading .fd files produced by fdesign (in
 libforms-bin).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk-options
Architecture: any
Multi-Arch: foreign
Section: x11
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: Fast Light Toolkit - library option manager
 This package provides a tool for viewing and setting overall FLTK options
 interactively or programmatically.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.4-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends:
 dpkg-dev,
 libcairo2-dev,
 libfltk-cairo1.4 (= ${binary:Version}),
 libfltk-forms1.4 (= ${binary:Version}),
 libfltk-gl1.4 (= ${binary:Version}),
 libfltk-images1.4 (= ${binary:Version}),
 libfltk1.4 (= ${binary:Version}),
 libx11-dev,
 ${misc:Depends},
Recommends:
 fluid,
 libgl-dev,
 libglu1-mesa-dev | libglu-dev,
Suggests:
 fltk1.4-doc,
 libjpeg-dev,
 libpng-dev,
 libxext-dev,
 libxft-dev,
 libxinerama-dev,
 zlib1g-dev | libz-dev,
Conflicts:
 libfltk-dev,
Provides:
 libfltk-dev,
Replaces:
 libfltk-dev,
Description: Fast Light Toolkit - development files
 This package provides the files necessary for compiling programs
 that depend on FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk1.4-compat-headers
Architecture: all
Multi-Arch: foreign
Section: libdevel
Depends:
 libfltk1.4-dev,
 ${misc:Depends},
Conflicts:
 libfltk1.3-compat-headers,
 libfltk-compat-headers,
Provides:
 libfltk1.3-compat-headers,
 libfltk-compat-headers,
Replaces:
 libfltk1.3-compat-headers,
 libfltk-compat-headers,
Description: Fast Light Toolkit - compatibility header symlinks
 This package provides header symlinks with .h rather than .H extensions for
 compatibility with some older code that relies on the lowercase-h names.

Package: libfltk1.4
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 fltk-options,
Pre-Depends:
 ${misc:Pre-Depends},
Description: Fast Light Toolkit - main shared library
 This package contains the files necessary for running programs
 dynamically linked with FLTK.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-cairo1.4
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Fast Light Toolkit - Cairo rendering layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Cairo rendering layer bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-forms1.4
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Fast Light Toolkit - Forms compatibility layer support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's Forms compatibility layer.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-gl1.4
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Fast Light Toolkit - OpenGL rendering support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's OpenGL rendering bindings.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: libfltk-images1.4
Architecture: any
Multi-Arch: same
Depends:
 libfltk1.4 (= ${binary:Version}),
 ${misc:Depends},
 ${shlibs:Depends},
Pre-Depends:
 ${misc:Pre-Depends},
Description: Fast Light Toolkit - image loading support
 This package contains the files necessary for running programs
 dynamically linked with FLTK's bindings to image-loading libraries.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.4-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Depends:
 ${misc:Depends},
Description: Fast Light Toolkit - documentation
 This package provides documentation for FLTK, including a chapter on
 its user interface designer (fluid).
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.

Package: fltk1.4-games
Architecture: any
Multi-Arch: foreign
Section: games
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 ${shlibs:Recommends},
Conflicts:
 fltk1.1-games,
 fltk1.3-games,
Replaces:
 fltk1.1-games,
 fltk1.3-games,
Description: Fast Light Toolkit - example games: checkers, sudoku
 This package contains the example games that accompany FLTK.
 Specifically, it contains the following two programs:
  - flblocks:   clear groups of adjacent blocks before they fill the screen;
  - flcheckers: classic board game, also known as draughts;
  - flpuzzle:   Klotski puzzle (slide blocks around);
  - flsudoku:   Sudoku puzzle (place numbers in a grid).
 .
 NB: flpuzzle has a heavier dependency chain than the other games; playing
 it requires having this package's recommendations installed.
 .
 The Fast Light Toolkit (FLTK) is a cross-platform graphical user interface
 toolkit originally based on libForms.
